[PATCH] guilt-header: Add -e option for editing
[guilt.git] / guilt
blob7f2b93c1a30fc73eca512f56663d05f62fb00cba
1 #!/bin/sh
3 # Copyright (c) Josef "Jeff" Sipek, 2006, 2007
6 GUILT_VERSION="0.26"
7 GUILT_NAME="Los"
9 # If the first argument is one of the below, display the man page instead of
10 # the rather silly and mostly useless usage string
11 case $1 in
12 -h|--h|--he|--hel|--help)
13 shift
14 exec "guilt-help" "$@"
15 exit
17 -V|--ver|--versi|--versio|--version)
18 echo "Guilt version $GUILT_VERSION"
19 exit
21 esac
23 # we change directories ourselves
24 SUBDIRECTORY_OK=1
26 . git-sh-setup
29 # Git version check
31 gitver=`git --version | cut -d' ' -f3`
32 case "$gitver" in
33 1.5.*) ;; # git-config
34 *) die "Unsupported version of git ($gitver)" ;;
35 esac
38 # Shell library
41 # echo -e is a bashism, fallback to /bin/echo if the builtin does not supports it
42 echo()
44 /bin/echo "$@"
47 noerr()
49 "$@" 2>/dev/null
52 silent()
54 "$@" >/dev/null 2>/dev/null
57 ########
59 guilt_commands()
61 find "`dirname $0`" -maxdepth 1 -name "guilt-*" -type f -perm /111 | sed -e "s/.*\\/`basename $0`-//"
64 if [ "`basename $0`" = "guilt" ]; then
65 # being run as standalone
67 # by default, we shouldn't fail
68 cmd=
70 if [ $# -ne 0 ]; then
71 # take first arg, and try to execute it
73 arg="$1"
74 dir=`dirname $0`
76 if [ -x "$dir/guilt-$arg" ]; then
77 cmd=$arg
78 else
79 # might be a short handed
80 for command in $(guilt_commands); do
81 case $command in
82 $arg*)
83 if [ -x "$dir/guilt-$command" ]; then
84 cmd=$command
87 esac
88 done
90 if [ -n "$cmd" ]; then
91 shift
92 exec "$dir/guilt-$cmd" "$@"
94 # this is not reached because of the exec
95 die "Exec failed! Something is terribly wrong!"
96 else
97 echo "Command $arg not found" >&2
98 echo "" >&2
102 # no args passed or invalid command entered, just output help summary
104 echo "Guilt v$GUILT_VERSION"
105 echo ""
106 echo "Pick a command:"
107 guilt_commands | sort | column | column -t | sed -e 's/^/\t/'
109 echo ""
110 echo "Example:"
111 echo -e "\tguilt-push"
112 echo "or"
113 echo -e "\tguilt push"
115 # now, let's exit
116 exit 1
119 ########
122 # Library goodies
125 # usage: valid_patchname <patchname>
126 valid_patchname()
128 case "$1" in
129 /*|./*|../*|*/./*|*/../*|*/.|*/..|*/)
130 return 1;;
132 return 0;;
133 esac
136 get_branch()
138 git-symbolic-ref HEAD | sed -e 's,^refs/heads/,,'
141 verify_branch()
143 [ ! -d "$GIT_DIR/patches" ] &&
144 echo "Patches directory doesn't exist, try guilt-init" >&2 &&
145 return 1
146 [ ! -d "$GIT_DIR/patches/$branch" ] &&
147 echo "Branch $branch is not initialized, try guilt-init" >&2 &&
148 return 1
149 [ ! -f "$GIT_DIR/patches/$branch/series" ] &&
150 echo "Branch $branch does not have a series file" >&2 &&
151 return 1
152 [ ! -f "$GIT_DIR/patches/$branch/status" ] &&
153 echo "Branch $branch does not have a status file" >&2 &&
154 return 1
155 [ -f "$GIT_DIR/patches/$branch/applied" ] &&
156 echo "Warning: Branch $branch has 'applied' file - guilt is not compatible with stgit" >&2 &&
157 return 1
159 return 0
162 get_top()
164 tail -1 "$GUILT_DIR/$branch/status" | cut -d: -f 2-
167 get_prev()
169 if [ `wc -l < "$GUILT_DIR/$branch/status"` -gt 1 ]; then
170 tail -n 2 "$GUILT_DIR/$branch/status" | head -n 1
174 get_series()
176 # ignore all lines matching:
177 # - empty lines
178 # - whitespace only
179 # - optional whitespace followed by '#' followed by more
180 # optional whitespace
181 grep -ve '^[[:space:]]*\(#.*\)*$' "$series"
184 # usage: do_make_header <hash>
185 do_make_header()
187 # we should try to work with commit objects only
188 if [ `git-cat-file -t "$1"` != "commit" ]; then
189 echo "Hash $1 is not a commit object" >&2
190 echo "Aborting..." >&2
191 exit 2
194 git-cat-file -p "$1" | awk '
195 BEGIN{headers=1; firstline=1}
196 /^author / && headers {
197 sub(/^author +/, "");
198 sub(/ [0-9]* [+-]*[0-9][0-9]*$/, "");
199 author=$0
201 !headers {
202 print
203 if (firstline) {
204 firstline = 0;
205 print "\nFrom: " author;
208 /^$/ && headers { headers = 0 }
212 # usage: do_get_patch patchfile
213 do_get_patch()
215 cat "$1" | awk '
216 BEGIN{}
217 /^(diff|---)/,/END{}/
221 # usage: do_get_header patchfile
222 do_get_header()
224 # The complexity arises from the fact that we want to ignore the
225 # From line and the empty line after it if it exists
227 # 2nd line skips the From line
228 # 3rd line skips the empty line right after a From line
229 # 4th line terminates execution when we encounter the diff
230 cat "$1" | awk '
231 BEGIN{skip=0}
232 /^Subject:/ && (NR==1){print substr($0, 10); next}
233 /^From:/{skip=1; next}
234 /^[ \t\f\n\r\v]*$/ && (skip==1){skip=0; next}
235 /^(diff|---)/{exit}
236 {print $0}
237 END{}
241 # usage: do_get_full_header patchfile
242 do_get_full_header()
244 # 2nd line checks for the begining of a patch
245 # 3rd line outputs the line if it didn't get pruned by the above rules
246 cat "$1" | awk '
247 BEGIN{}
248 /^(diff|---)/{exit}
249 {print $0}
250 END{}
254 # usage: assert_head_check
255 assert_head_check()
257 if ! head_check "`tail -1 < "$applied" | cut -d: -f 1`"; then
258 die "aborting..."
262 # usage: head_check <expected hash>
263 head_check()
265 # make sure we're not doing funky things to commits that don't
266 # belong to us
267 # if the expected hash is empty, just return
268 [ -z "$1" ] && return 0
270 if [ "`git show-ref -s "refs/heads/$branch"`" != "$1" ]; then
271 echo "Expected HEAD commit $1" >&2
272 echo " got `cat "$GIT_DIR/refs/heads/$branch"`" >&2
273 return 1
275 return 0
278 # usage: series_insert_patch <patchname>
279 series_insert_patch()
281 awk -v top="`get_top`" -v new="$1" \
282 'BEGIN{if (top == "") print new;}
284 print $0;
285 if (top != "" && top == $0) print new;
286 }' "$series" > "$series.tmp"
287 mv "$series.tmp" "$series"
290 # usage: series_remove_patch <patchname>
291 series_remove_patch()
293 grep -v "^$1\$" < "$series" > "$series.tmp"
294 mv "$series.tmp" "$series"
297 # usage: series_rename_patch <oldname> <newname>
298 series_rename_patch()
300 awk -v old="$1" -v new="$2" \
301 '{ if ($0 == old) print new; else print $0 }' \
302 "$series" > "$series.tmp"
304 mv "$series.tmp" "$series"
307 # Beware! This is one of the few (only?) places where we modify the applied
308 # file directly
310 # usage: applied_rename_patch <oldname> <newname>
311 applied_rename_patch()
313 awk -v old="$1" -v new="$2" \
314 'BEGIN{FS=":"}
315 { if ($1 ~ /^[0-9a-f]*$/ && length($1) == 40 && substr($0, 42) == old)
316 print substr($0, 0, 41) new;
317 else
318 print;
319 }' "$applied" > "$applied.tmp"
321 mv "$applied.tmp" "$applied"
324 # usage: pop_many_patches <commitish> <number of patches>
325 pop_many_patches()
327 assert_head_check
330 cd "$TOP_DIR"
332 git-reset --hard "$1" > /dev/null
333 head -n "-$2" < "$applied" > "$applied.tmp"
334 mv "$applied.tmp" "$applied"
337 # update references to top, bottom, and base
338 update_stack_tags
341 # usage: pop_all_patches
342 pop_all_patches()
344 pop_many_patches \
345 `head -1 "$applied" | cut -d: -f1`^ \
346 `wc -l < "$applied"`
349 # usage: update_stack_tags
350 update_stack_tags()
352 # bail if autotagging is not enabled
353 if [ $autotag -eq 0 ]; then
354 return 0
357 if [ -s "$applied" ]; then
358 # there are patches applied, therefore we must get the top,
359 # bottom and base hashes, and update the tags
361 mkdir -p `dirname "$GIT_DIR/refs/tags/${branch}_top"`
362 git-rev-parse HEAD > "$GIT_DIR/refs/tags/${branch}_top"
363 head -1 < $applied | cut -d: -f1 > "$GIT_DIR/refs/tags/${branch}_bottom"
364 git-rev-parse $(head -1 < $applied | cut -d: -f1)^ > "$GIT_DIR/refs/tags/${branch}_base"
365 else
366 # there are no patches applied, therefore we must remove the
367 # tags to old top, bottom, and base
369 rm -f "$GIT_DIR/refs/tags/${branch}_top"
370 rm -f "$GIT_DIR/refs/tags/${branch}_bottom"
371 rm -f "$GIT_DIR/refs/tags/${branch}_base"
375 # usage: push_patch patchname [bail_action]
376 push_patch()
378 __push_patch_bail=0
381 p="$GUILT_DIR/$branch/$1"
382 pname="$1"
383 bail_action="$2"
384 reject="--reject"
386 assert_head_check
387 cd "$TOP_DIR"
389 # apply the patch if and only if there is something to apply
390 if [ `git-apply --numstat "$p" | wc -l` -gt 0 ]; then
391 if [ "$bail_action" = abort ]; then
392 reject=""
394 git-apply -C$guilt_push_diff_context --index \
395 $reject "$p" > /dev/null 2> /tmp/guilt.log.$$
396 __push_patch_bail=$?
398 if [ $__push_patch_bail -ne 0 ]; then
399 cat /tmp/guilt.log.$$ >&2
400 if [ "$bail_action" = "abort" ]; then
401 rm -f /tmp/guilt.log.$$ /tmp/guilt.msg.$$
402 return $__push_patch_bail
407 # grab a commit message out of the patch
408 do_get_header "$p" > /tmp/guilt.msg.$$
410 # make a default commit message if patch doesn't contain one
411 [ ! -s /tmp/guilt.msg.$$ ] && echo "patch $pname" > /tmp/guilt.msg.$$
413 # extract a From line from the patch header, and set
414 # GIT_AUTHOR_{NAME,EMAIL}
415 author_str=`sed -n -e '/^From:/ { s/^From: //; p; q }; /^(diff|---)/ q' "$p"`
416 if [ ! -z "$author_str" ]; then
417 GIT_AUTHOR_NAME=`echo $author_str | sed -e 's/ *<.*$//'`
418 export GIT_AUTHOR_NAME="${GIT_AUTHOR_NAME:-" "}"
419 export GIT_AUTHOR_EMAIL="`echo $author_str | sed -e 's/[^<]*//'`"
421 export GIT_AUTHOR_DATE="`stat -c %y "$p"`"
422 export GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"
424 # commit
425 treeish=`git-write-tree`
426 commitish=`git-commit-tree $treeish -p HEAD < /tmp/guilt.msg.$$`
427 echo $commitish > $GIT_DIR/`git-symbolic-ref HEAD`
429 # mark patch as applied
430 echo "$commitish:$pname" >> $applied
433 # sub-shell funky-ness
434 __push_patch_bail=$?
436 # update references to top, bottom, and base of the stack
437 update_stack_tags
439 rm -f /tmp/guilt.msg.$$ /tmp/guilt.log.$$
440 return $__push_patch_bail
443 # usage: must_commit_first
444 must_commit_first()
446 [ `git-diff-files | wc -l` -eq 0 ]
447 return $?
450 # usage: fold_patch patchname
451 fold_patch()
453 set -- "$1" "`get_top`"
455 assert_head_check
457 push_patch "$1"
459 __refresh_patch "$2" HEAD^^ 2 "" ""
461 series_remove_patch "$1"
464 # usage: refresh_patch patchname gengitdiff incldiffstat
465 refresh_patch()
467 __refresh_patch "$1" HEAD^ 1 "$2" "$3"
470 # usage: __refresh_patch patchname commitish number_of_commits gengitdiff
471 # incldiffstat
472 __refresh_patch()
474 assert_head_check
477 cd "$TOP_DIR"
478 p="$GUILT_DIR/$branch/$1"
480 git-diff-files --name-only | (while read n; do git-update-index "$n" ; done)
482 # get the patch header
483 do_get_full_header "$p" > /tmp/guilt.diff.$$
485 [ ! -z "$4" ] && diffopts="-C -M --find-copies-harder"
487 if [ ! -z "$5" ]; then
489 echo "---"
490 git-diff --stat $diffopts "$2"
491 echo ""
492 ) >> /tmp/guilt.diff.$$
495 # get the new patch
496 git-diff $diffopts "$2" >> /tmp/guilt.diff.$$
498 # move the new patch in
499 mv "$p" "$p~"
500 mv /tmp/guilt.diff.$$ $p
503 # drop the currently applied patch, pop_many_patches does it's own
504 # cd $TOP_DIR
505 pop_many_patches "$2" "$3"
507 # push_patch does it's own cd $TOP_DIR
508 push_patch "$1"
511 # usage: munge_hash_range <hash range>
513 # this means:
514 # <hash> - one commit
515 # <hash>.. - hash until head (excludes hash, includes head)
516 # ..<hash> - until hash (includes hash)
517 # <hash1>..<hash2> - from hash to hash (inclusive)
519 # The output of this function is suitable to be passed to git-rev-list
520 munge_hash_range()
522 case "$1" in
523 *..*..*|*\ *)
524 # double .. or space is illegal
525 return 1;;
526 ..*)
527 # e.g., "..v0.10"
528 echo ${1#..};;
529 *..)
530 # e.g., "v0.19.."
531 echo ${1%..}..HEAD;;
532 *..*)
533 # e.g., "v0.19-rc1..v0.19"
534 echo ${1%%..*}..${1#*..};;
536 # e.g., "v0.19"
537 echo $1^..$1;;
538 *) # empty
539 return 1;;
540 esac
541 return 0
544 # usage: guilt_hook <hook name> <args....>
545 guilt_hook()
547 __hookname="$1"
548 [ ! -x "$GIT_DIR/hooks/guilt/$__hookname" ] && return 0
550 shift
552 "$GIT_DIR/hooks/guilt/$__hookname" "$@"
553 return $?
557 # Some constants
560 # used for: git-apply -C <val>
561 guilt_push_diff_context=1
564 # Parse any part of .git/config that belongs to us
567 # autotag?
568 autotag=`git-config guilt.autotag`
569 [ -z "$autotag" ] && autotag=1
572 # The following gets run every time this file is source'd
575 TOP_DIR=`git-rev-parse --show-cdup`
576 if [ -z "$TOP_DIR" ]; then
577 TOP_DIR="./"
580 GUILT_DIR="$GIT_DIR/patches"
582 branch=`get_branch`
584 # most of the time we want to verify that the repo's branch has been
585 # initialized, but every once in a blue moon (e.g., we want to run guilt-init),
586 # we must avoid the checks
587 if [ -z "$DO_NOT_CHECK_BRANCH_EXISTENCE" ]; then
588 verify_branch || exit 1
591 # very useful files
592 series="$GUILT_DIR/$branch/series"
593 applied="$GUILT_DIR/$branch/status"
595 # determine an editor to use for anything interactive (fall back to vi)
596 editor="vi"
597 [ ! -z "$EDITOR" ] && editor="$EDITOR"
599 # determine a pager to use for anything interactive (fall back to more)
600 pager="more"
601 [ ! -z "$PAGER" ] && pager="$PAGER"